<template>
    <div class="resultlist">
        <div class="results" >
            <ul >
                <li class="media" v-for="(newsItem, index) in news" :key="'result'+ index" :value="newsItem">
                    <div>
                        <a v-bind:href="newsItem.url" target="_blank">
                            <img class="media-img" :style="{backgroundImage: 'url(' + newsItem.urlToImage + ')'}">
                        </a>
                    </div>
                    <div class="media-content">
                        <a v-bind:href="newsItem.url" target="_blank">{{newsItem.title}}</a>
                        <h5>
                            <i>by {{newsItem.author}}</i>
                        </h5>
                        <p>
                            {{newsItem.description}}
                        </p>
                    </div>
                </li>
            </ul>
        </div>
        <div class="paginator">
            <button @click="prev"> previous </button>
            <p class="current-page">Page {{currentPage}} of {{pageCount}}</p>
            <button @click="next"> next </button>
        </div>
    </div>
</template>

<script>
    export default {
        name: 'resultlist',
        props: {
            news: {
                type: Array,
                required: true
                    },
            totalResults:{
                type: Number,
                    }
            },   
        data(){
             return{
                articles:[], 
                currentPage:1,
                maxPerPage:10
                }
                },
          
        computed: {
              pageCount() {
                return Math.ceil(this.totalResults / this.maxPerPage);
              },
              isFirstPage() {
                return this.currentPage === 1
              },
              isLastPage() {
                return this.currentPage >= this.pageCount
              },
          },
        methods: {
                next() {
                if (this.isLastPage) return
                this.currentPage += 1;
                },
                prev() {
                if (this.isFirstPage) return
                this.currentPage -= 1;
                },
                newPageNumbe:function(){
                 this.$emit('newPageNumber', this.currentPage);
                }
            },
        watch: {
            currentPage: function(val){
                this.currentPage = val ;
                 this.newPageNumbe();
            }
        }

    }
</script>

<style scoped>
    .resultlist{
        margin-top: 32px;
        border-radius: 4px;
        padding: 16px;
        box-shadow: 1px 1px 5px 1px rgba(0,0,0,.3);
        background: rgb(255, 255, 255,0.7);
        min-height: 360px;
    }

    .results {
        max-height: 800px;
        overflow-y: scroll;
        margin: 16px 0;
    }

    .media-img{
        height: 100%;
        width: 260px;
        background-size: cover;
        background-repeat: no-repeat;
        margin-right: 16px;
        background-position: center;
    }

    ul {
        list-style: none;
        height:360px;
    }

    .media {
        height: 200px;
        display: flex;
    }

    .media:not(:last-child) {
        margin-bottom: 32px;
    }
    
    .media-content {
        height: 200px;
    }

    .media-content a{
        color: rgb(52, 133, 133);
        text-decoration: none;
        font-size: 18px;
    }
    .paginator {
        display: flex;
        justify-content: center;
        align-items: center;
    }

    .paginator button {
        cursor: pointer;
        outline: none;
        border: 0;
        height: 32px;
        width: 64px;
        background: rgb(52, 133, 133);
        color: #fff;
        position: relative;
    }

    .current-page {
        margin: 0 16px;
    }
</style>